(*********************************************************************)
(*                         Diy                                       *)
(*                                                                   *)
(*   Jade Alglave, Luc Maranget INRIA Paris-Rocquencourt, France.    *)
(*                                                                   *)
(*  Copyright 2010 Institut National de Recherche en Informatique et *)
(*  en Automatique. All rights reserved. This file is distributed    *)
(*  under the terms of the Lesser GNU General Public License.        *)
(*********************************************************************)

module Make(V:Constant.S) =
struct
  include PPCBase

  type fence = Sync | LwSync

  let strong = Sync

  let pp_fence = function
    | Sync -> "Sync"
    | LwSync -> "LwSync"

  let sig_of_fence = function
    | Sync -> 'S'
    | LwSync -> 'L'


  let fold_fences f r = f Sync (f LwSync r)

  open Code

  let orders f d1 d2 = match f,d1,d2 with
  | Sync,_,_ -> true
  | LwSync,W,R -> false
  | LwSync,_,_ -> true



  module V = V
  include
      ArchExtra.Make
      (struct
        type arch_reg = reg
        let pp_reg = pp_reg
        let free_registers = allowed_for_symb
      end)
end
