(*********************************************************************)
(*                         Diy                                       *)
(*                                                                   *)
(*   Jade Alglave, Luc Maranget INRIA Paris-Rocquencourt, France.    *)
(*                                                                   *)
(*  Copyright 2010 Institut National de Recherche en Informatique et *)
(*  en Automatique. All rights reserved. This file is distributed    *)
(*  under the terms of the Lesser GNU General Public License.        *)
(*********************************************************************)

module type S = sig
  module A : Arch.S

  module E : Edge.S with type fence = A.fence

  module R : Relax.S
  with type fence = A.fence
  and type edge = E.edge

  
  module C : Cycle.S with type edge=E.edge
end

module Make(A:Arch.S) =
struct
  module A = A 
  module E =  Edge.Make(A)
  module R = Relax.Make(A) (E)
  module C = Cycle.Make(E)
end

