/*********************************************************************/
/*                          Litmus                                   */
/*                                                                   */
/*        Luc Maranget, INRIA Paris-Rocquencourt, France.            */
/*        Susmit Sarkar, University of Cambridge, UK.                */
/*                                                                   */
/*  Copyright 2010 Institut National de Recherche en Informatique et */
/*  en Automatique and the authors. All rights reserved.             */
/*  This file is distributed  under the terms of the Lesser GNU      */
/*  General Public License.                                          */
/*********************************************************************/

#include <stdio.h>
#include <sys/processor.h>
#include <sys/thread.h>
#include "affinity.h"

#if 0
static void pp_set(FILE *fp, cpus_t *p) {  
  for (int k = 0 ; k < p->sz ; k++) {
    fprintf(fp," %i", p->cpu[k]) ;
  }
  fprintf(fp,"\n") ;
}
#endif



cpus_t *read_affinity(void) {
  int n_online = sysconf(_SC_NPROCESSORS_ONLN);
  cpus_t *r ;
  if (n_online < 0) {
    err(1,"sysconf") ;
  }
  int sz = n_online ;
  r = cpus_create(sz) ;
  for (int p=0, *q=r->cpu ; p <  sz ; p++) {
    *q++ = p ;
  }
  return r ;
}

void write_affinity(cpus_t *p) {
  return ;
}

void write_one_affinity(int a) {
  if (a >= 0) {
    int tid = thread_self();
    if (bindprocessor(BINDTHREAD, tid, a) < 0) {
      err(1,"bindprocessor") ;
    }
  }  
}

